-- Gyri Button osztly
-- *************************************************
TButton = class(Turbine.UI.Lotro.Button);
function TButton:Constructor(parent, text, left, top, width, height)
	Turbine.UI.Lotro.Button.Constructor( self );
	if (width ~= nil) and (height ~= nil) then self:SetSize(width, height);	end
	if (left ~= nil) and (top ~= nil) then self:SetPosition(left, top);	end
	if (text ~= nil) then self:SetText(text); end;
	if (parent ~= nil) then self:SetParent(parent);	end
end

-- Label osztly
-- *************************************************
TLabel = class(Turbine.UI.Label);
function TLabel:Constructor(parent, text, left, top, width, height)
	Turbine.UI.Label.Constructor( self );
	self.pFont = Turbine.UI.Lotro.Font.Verdana16;
	self.pColor = Turbine.UI.Color(1,1,1);
	
	self:SetFont(self.pFont);
	self:SetForeColor(self.pColor);
	if (width ~= nil) and (height ~= nil) then self:SetSize(width, height);	end
	if (left ~= nil) and (top ~= nil) then self:SetPosition(left, top);	end
	if (text ~= nil) then self:SetText(text); end;
	if (parent ~= nil) then self:SetParent(parent);	end
end

-- Edit osztly
-- *************************************************
TEdit = class(Turbine.UI.Lotro.TextBox);
function TEdit:Constructor(parent, left, top, width, height)
	Turbine.UI.Lotro.TextBox.Constructor( self );
	self.pFont = Turbine.UI.Lotro.Font.Verdana16;
	self.pColor = Turbine.UI.Color(1,1,1);
	
	self:SetFont(self.pFont);
	self:SetForeColor(self.pColor);
	if (width ~= nil) and (height ~= nil) then self:SetSize(width, height);	end
	if (left ~= nil) and (top ~= nil) then self:SetPosition(left, top);	end
	if (parent ~= nil) then self:SetParent(parent);	end	
end

-- *************************************************
-- Sajt grafikus button osztly
-- *************************************************
TImageButton = class(Turbine.UI.Button);
function TImageButton:Constructor(parent, left, top, width, height, normal, pressed, rollover)
	Turbine.UI.Button.Constructor( self );
	if (width ~= nil) and (height ~= nil) and (left ~= nil) and (top ~= nil) then
		self:SetSize(width, height);		
		self:SetPosition(left, top);
		self:SetParent(parent);
	end
	if normal ~= nil then
		self:SetBlendMode(Turbine.UI.BlendMode.Overlay);
		self:SetBackground(normal)
		self.MouseLeave=function() self:SetBackground(normal) end
		if rollover ~= nil then
			self.MouseEnter=function() self:SetBackground(rollover) end		
			self.MouseUp=function() self:SetBackground(rollover) end	
		end
		if pressed ~= nil then
			self.MouseDown=function() self:SetBackground(pressed) end			
		end
	end
end

--	Slot sorrend
SlotOrder = {
	Turbine.Gameplay.Equipment.PrimaryWeapon,
	Turbine.Gameplay.Equipment.SecondaryWeapon,
	Turbine.Gameplay.Equipment.RangedWeapon,
	Turbine.Gameplay.Equipment.Class,
	
	Turbine.Gameplay.Equipment.Earring1,
	Turbine.Gameplay.Equipment.Earring2,
	Turbine.Gameplay.Equipment.Necklace,
	Turbine.Gameplay.Equipment.Bracelet1,
	Turbine.Gameplay.Equipment.Bracelet2,
	Turbine.Gameplay.Equipment.Ring1,
	Turbine.Gameplay.Equipment.Ring2,
	Turbine.Gameplay.Equipment.Pocket,
	
	Turbine.Gameplay.Equipment.Head,
	Turbine.Gameplay.Equipment.Shoulder,
	Turbine.Gameplay.Equipment.Back,
	Turbine.Gameplay.Equipment.Chest,
	Turbine.Gameplay.Equipment.Gloves,
	Turbine.Gameplay.Equipment.Legs,
	Turbine.Gameplay.Equipment.Boots,
}

--	Slot httrkpek
SlotProps = {
	[Turbine.Gameplay.Equipment.PrimaryWeapon] = {['name']="PrimaryWeapon", ['bgImage']=0x41007eea},
	[Turbine.Gameplay.Equipment.SecondaryWeapon] = {['name']="SecondaryWeapon", ['bgImage']=0x41007eeb},
	[Turbine.Gameplay.Equipment.RangedWeapon] = {['name']="RangedWeapon", ['bgImage']=0x41007eec},
	[Turbine.Gameplay.Equipment.Class] = {['name']="Class", ['bgImage']=0x410e8680},
	
	[Turbine.Gameplay.Equipment.Earring1] = {['name']="Earring1", ['bgImage']=0x41007ef6},
	[Turbine.Gameplay.Equipment.Earring2] = {['name']="Earring2", ['bgImage']=0x41007ef7},
	[Turbine.Gameplay.Equipment.Necklace] = {['name']="Necklace", ['bgImage']=0x41007eef},
	[Turbine.Gameplay.Equipment.Bracelet1] = {['name']="Bracelet1", ['bgImage']=0x41007ef8},
	[Turbine.Gameplay.Equipment.Bracelet2] = {['name']="Bracelet2", ['bgImage']=0x41007ef9},
	[Turbine.Gameplay.Equipment.Ring1] = {['name']="Ring1", ['bgImage']=0x41007ef3},
	[Turbine.Gameplay.Equipment.Ring2] = {['name']="Ring2", ['bgImage']=0x41007ef4},
	[Turbine.Gameplay.Equipment.Pocket] = {['name']="Pocket", ['bgImage']=0x41007efa},
	
	[Turbine.Gameplay.Equipment.Head] = {['name']="Head", ['bgImage']=0x41007eed},
	[Turbine.Gameplay.Equipment.Shoulder] = {['name']="Shoulder", ['bgImage']=0x41007eee},
	[Turbine.Gameplay.Equipment.Chest] = {['name']="Chest", ['bgImage']=0x41007ef0},
	[Turbine.Gameplay.Equipment.Back] = {['name']="Back", ['bgImage']=0x41007ee9},
	[Turbine.Gameplay.Equipment.Gloves] = {['name']="Gloves", ['bgImage']=0x41007ef2},
	[Turbine.Gameplay.Equipment.Legs] = {['name']="Legs", ['bgImage']=0x41007ef1},
	[Turbine.Gameplay.Equipment.Boots] = {['name']="Boots", ['bgImage']=0x41007ef5},
};

-- *************************************************
-- Viselt item megjelentse
-- *************************************************
TWearSlot = class(Turbine.UI.Control);
function TWearSlot:Constructor(pParent, pLeft, pTop, pSlot)
	Turbine.UI.Control.Constructor( self );
	self.slot = pSlot;
	self.ESlot = Turbine.UI.Lotro.EquipmentSlot();
	
	self:SetPosition(pLeft, pTop);
	self:SetSize(41,41);
	self:SetParent(pParent);
	self:SetBackground(SlotProps[pSlot]['bgImage']);
	self:SetBlendMode(Turbine.UI.BlendMode.Overlay);

	self.ESlot:SetPosition(3,3);
	self.ESlot:SetSize(36,36);
	self.ESlot:SetParent(self);
	self.ESlot:SetEquipmentSlot(self.slot);	
end
function TWearSlot:GetName()
	if (playerEquipment:GetItem(self.slot) ~= nil) then
		return playerEquipment:GetItem(self.slot):GetName();
	else
		return "";
	end
end

-- *************************************************
-- Cserre vr item shortcutja
-- *************************************************
TItemSlot = class(Turbine.UI.Control);
function TItemSlot:Constructor(pParent, pLeft, pTop, pSlot, pDefault, pIsMain)
	Turbine.UI.Control.Constructor( self );
	self.slot = pSlot;
	self.ISlot = Turbine.UI.Lotro.Quickslot();	
	self:SetPosition(pLeft, pTop);
	self:SetSize(41,41);
	self:SetParent(pParent);
	self:SetBackground(SlotProps[pSlot]['bgImage']);
	self:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.ISlot:SetPosition(3,3);
	self.ISlot:SetSize(36,36);
	self.ISlot:SetParent(self);
	self.ISlot:SetUseOnRightClick(false);
	self:SetItem(pDefault);	
	if (pIsMain == false) then
		-- Opci ablakban van egrklikk event
		self.ISlot.MouseClick = function(sender, args)
			-- sender az ISlot
			if args.Button == 2 then
				if sender:GetShortcut():GetItem() ~= nil then
					local itemName = sender:GetShortcut():GetItem():GetName();
					debug(itemName .. " removed");
					sender:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item));							
				else
					debug("Empty slot cannot remove");
				end
			end
		end		
	end
end

function TItemSlot:SetItem(pDefault)
	if ((pDefault ~= "") and (pDefault ~= nil)) then
		self.ISlot:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item, pDefault));		
	end		
end

function TItemSlot:GetItem()
	if (self.ISlot:GetShortcut():GetItem() ~= nil) then
		return self.ISlot:GetShortcut():GetData();
	else
		return "";		
	end	
end

function TItemSlot:GetName()
	if (self.ISlot:GetShortcut():GetItem() ~= nil) then
		return self.ISlot:GetShortcut():GetItem():GetName();
	else
		return "";		
	end
end

function TItemSlot:SetStatus(status)
	if status == nil then status = "ok"	end
	if status == "ok" then
		self:SetBackColor(Turbine.UI.Color( 0, 0, 0, 0 ));
		self:SetBackColorBlendMode(Turbine.UI.BlendMode.None);	
	end		
	if status == "wrong" then
		self:SetBackColor(Turbine.UI.Color( .8, .8, 0, 0 ));
		self:SetBackColorBlendMode(Turbine.UI.BlendMode.Screen);		
	end
	if status == "multi" then
		self:SetBackColor(Turbine.UI.Color( .8, .8, .8, 0 ));
		self:SetBackColorBlendMode(Turbine.UI.BlendMode.Screen);	
	end		
end
